from django.db import models
from django.contrib.auth.models import User, Group
from django.contrib.auth.models import AbstractUser
from dashboard.models import Package, ExpenseType, Bank, PaymentMode, BankTransactionType, CompanyLocation
from django.contrib.auth.models import BaseUserManager, AbstractBaseUser, PermissionsMixin
# Create your models here.



class  User_type(models.Model):
    name = models.CharField(max_length=200 , blank=False ,null=False)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    

class Roles(models.Model):
    name = models.CharField(max_length=200, default='User')
    
    # administration
    company_location = models.BooleanField(default=False)
    company_profile = models.BooleanField(default=False)
    product_category = models.BooleanField(default=False)
    products = models.BooleanField(default=False)
    product_prices = models.BooleanField(default=False)
    product_stocks = models.BooleanField(default=False)
    customers = models.BooleanField(default=False)
    suppliers = models.BooleanField(default=False)
    role = models.BooleanField(default=False)
    bank_accounts = models.BooleanField(default=False)
    users = models.BooleanField(default=False)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    
    # reference
    package = models.BooleanField(default=False)
    expense_type = models.BooleanField(default=False)
    bank = models.BooleanField(default=False)
    payment_method = models.BooleanField(default=False)
    bank_transaction_type = models.BooleanField(default=False)
    
    # HR Roles
    add_staff = models.BooleanField(default=False)
    generate_payroll = models.BooleanField(default=False)
    print_payroll = models.BooleanField(default=False)
    
    #Transaction
    cash_sale = models.BooleanField(default=False)
    credit_sale = models.BooleanField(default=False)
    can_approve_credit_sale = models.BooleanField(default=False)
    stock_purchase = models.BooleanField(default=False)
    stock_transfer = models.BooleanField(default=False)
    wholesale = models.BooleanField(default=False)
    protocol = models.BooleanField(default=False)
    expense = models.BooleanField(default=False)
    bank_transaction = models.BooleanField(default=False)
    can_print_sales = models.BooleanField(default=False)
    can_return_sales = models.BooleanField(default=False)
    can_approve_stock = models.BooleanField(default=False)
    
    # Transaction Payment
    credit_sale_payment = models.BooleanField(default=False)
    stock_purchase_payment = models.BooleanField(default=False)
    
    #Transaction Returns
    sale_return = models.BooleanField(default=False)
    stock_purchase_return = models.BooleanField(default=False)
    stock_transfer_return = models.BooleanField(default=False)
    protocol_return = models.BooleanField(default=False)
    
    # Transaction Update
    stock_damage_return = models.BooleanField(default=False)
    stock_purchase_update = models.BooleanField(default=False)
    sale_update = models.BooleanField(default=False)
    
    # Reports
    sale_report = models.BooleanField(default=False)
    sale_summary_report = models.BooleanField(default=False)
    customer_account_report = models.BooleanField(default=False)
    customer_statement_report = models.BooleanField(default=False)
    supplier_account_report = models.BooleanField(default=False)
    supplier_statement_report = models.BooleanField(default=False)
    product_sale_report = models.BooleanField(default=False)
    stock_value_report = models.BooleanField(default=False)
    stock_control_report = models.BooleanField(default=False)
    stock_purchase_report = models.BooleanField(default=False)
    stock_transfer_report = models.BooleanField(default=False)
    protocol_report = models.BooleanField(default=False)
    product_purchase_report = models.BooleanField(default=False)
    transaction_return_report = models.BooleanField(default=False)
    user_activity_report = models.BooleanField(default=False)
    credit_repayment_report = models.BooleanField(default=False)
    expenses_report = models.BooleanField(default=False)
    bank_transaction_report = models.BooleanField(default=False)
    customer_performance_report = models.BooleanField(default=False)
    stock_control_summary_report = models.BooleanField(default=False)
    credit_sale_approval_report = models.BooleanField(default=False)
    approved_stocks_report = models.BooleanField(default=False)
    
    is_active = models.BooleanField(default=True)
    
    class Meta:
        verbose_name_plural = "Roles"
    
    def __str__(self):
        return self.name



class Acount_User(AbstractUser):

    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    companyLocation = models.ForeignKey(CompanyLocation, related_name='Package',on_delete=models.SET_NULL ,blank=True, null=True)
    roles = models.ForeignKey(Roles, related_name='Role',on_delete=models.SET_NULL ,blank=True, null=True)
    phone = models.CharField(max_length=200 , blank=True ,null=True)
    
    
    def __str__(self):
        return self.username
    
    
    
    


# class UserAccountManager(BaseUserManager):
#   def create_user(self, username, full_name, phone, role, company_location, password=None):
    
#     if not username:
#       raise ValueError('Users must have an username')
#     if not company_location:
#       raise ValueError('Users must have a company location')
#     if not role:
#       raise ValueError('Users must have a role')
#     if not full_name:
#       raise ValueError('Users must have a full name')
  
#     user = self.model(
#         username=username,
#         full_name=full_name,
#         phone=phone,
#         role=role,
#         company_location=company_location,
#     )

#     user.set_password(password)
#     user.save(using=self._db)

#     return user

  
#   def create_superuser(self, username, full_name, password=None):
#     user = self.create_user(
#        username=username,
#         full_name=full_name,
#         password=password,
#     )

#     user.is_staff = True
#     user.is_superuser = True
#     user.save(using=self._db)

#     return user

# class Acount_User(AbstractBaseUser, PermissionsMixin):
#     created_at = models.DateTimeField(auto_now_add=True)
#     updated_at = models.DateTimeField(auto_now=True)
#     companyLocation = models.ForeignKey(CompanyLocation, related_name='Company',on_delete=models.SET_NULL ,blank=True, null=True)
#     roles = models.ForeignKey(Roles, related_name='Role',on_delete=models.SET_NULL ,blank=True, null=True)
#     phone = models.CharField(max_length=200 , blank=True ,null=True)
#     is_active = models.BooleanField(default=True)
#     is_staff = models.BooleanField(default=False)

#     objects = UserAccountManager()

#     USERNAME_FIELD = 'username'
#     REQUIRED_FIELDS = [
#                         'full_name',
#                         'role',
#                         'company_location'
#                         ]

#     def __str__(self):
#         return self.username